<?
/* QM Promisance - Turn-based strategy game
 * Copyright (C) 2001-2009 QMT Productions
 *
 * $URL: https://qmpromisance.svn.sourceforge.net/svnroot/qmpromisance/promisance/tags/release-4_2/lang/en-US/guide/manage.php $
 * $Id: manage.php 1516 2009-04-06 13:46:05Z quietust $
 */

if (!defined('IN_GUIDE'))
	die('Access denied');

guidepage($topic, 'manage', 'g_manage', 'Managing your Empire');
function g_manage ()
{
	global $era, $adminflag;
?>
<h2>Managing your Empire</h2>
<p>From this page, you may change several properties which govern your empire.</p>
<h3>Polymorph</h3>
<p>If you find yourself in a situation where the race of your empire's inhabitants prevents you from reaching a particular goal, you may, as a last resort, change your race. Beware, though, that changing your race will have serious side effects.</p>
<p>In order to polymorph, you must have a sufficient number of <?=lang($era->trpwiz)?>, at least <?=TURNS_INITIAL?> turns, and your health must be at least 75%.</p>
<p>The amount of energy required to polymorph will kill 10-15% of your population and military, destroy roughly 35% of your structures, and lose at least 15-45% of your stockpiles of <?=lang('ROW_CASH')?>, <?=lang($era->food)?>, and <?=lang($era->runes)?> amidst the chaos. Finally, <?=TURNS_INITIAL?> turns will be consumed, and your health will be reduced by 50%.</p>
<p>Note that if you made a mistake while selecting your race during signup, you may perform this procedure <b>for free</b> if you have not yet used any turns.</p>
<h3>Taxes</h3>
<p>Your tax rate determines not only the amount of money your empire's population contributes to you, but also their happiness - low tax rates will increase immigration, while high tax rates will drive your citizens away. Furthermore, raising your tax rate will reduce how far your empire's Health will recover itself.</p>
<h3>Industrial Allocation</h3>
<p>If you have built <?=lang($era->bldtrp)?> on your land, you may use these settings to control what types of units they will produce. When resources are allocated equally between all unit types, <?=lang($era->trparm)?>, <?=lang($era->trplnd)?>, <?=lang($era->trpfly)?>, and <?=lang($era->trpsea)?> will be produced in a 12:6:3:2 ratio.</p>
<p>Specifying percentages whose sum is less than 100% will cause your <?=lang($era->bldtrp)?> to run at partial capacity, which can be useful if your finances are temporarily unable to support additional troops.</p>
<?	if (VACATION_LIMIT != 0) { ?>
<h3>Vacation</h3>
<p>If, for some reason, you are unable to login for an extended period of time, you may set your empire on Vacation to protect it until you are able to return.</p>
<p>Once you choose to go on vacation, you will be locked out of your account; after <?=VACATION_START?> hours, your empire will be frozen and no other empires will be allowed to interact with you directly (though you will still share your troops with clanmates, and items already on the market will still be sold).</p>
<p>After your empire has been locked for a minimum of <?=VACATION_LIMIT?> hours, you will be allowed to login and unlock your empire at your own convenience, at which point you may resume normal gameplay. Do note that once the final week of gameplay for the current round has begun, your empire will be <i>automatically</i> unlocked at the earliest opportunity (so as to prevent players from using vacation to protect their high rank).</p>
<?	} ?>
<h2>Managing your User Account</h2>
<p>Several account settings are also available on this page - these settings will persist between empires and between rounds.</p>
<?	if ($adminflag == UFLAG_ADMIN) { ?>
<p>Note that if you use the "<?=lang('MAIN_SETUSER_SUBMIT')?>" functionality to assume the identity of an empire owned by another user, these functions will <i>not</i> allow you to alter their user account - they will always apply to your own account instead. If you wish to modify someone else's user account, go to <?=guidelink('admin/users', 'User Account Administration')?>.</p>
<?	} ?>
<h3>Theme</h3>
<p>Depending on the game's setup, multiple color schemes may be available for you to choose from. Simply select the one you wish to use and press "<?=lang('MANAGE_STYLE_SUBMIT')?>". The new style should take effect immediately.</p>
<h3>Change Password</h3>
<p>If you believe your password has been compromised (or if you simply haven't changed it in a while), you may change your account password here - simply enter your desired new password twice.</p>
<h3>Timezone</h3>
<p>All in-game times are typically tracked in the time zone in which the game's server itself is located - if you are located in a different time zone and wish to display times as they would be in your area, simply select your time zone from the dropdown list and press "<?=lang('MANAGE_TIMEZONE_SUBMIT')?>".</p>
<p>Each time this page is loaded, the current time will be displayed in your configured timezone. Note that Daylight Savings Time is not detected - when your local time switches to and from DST, you will need to update your account configuration accordingly.</p>
<h3>Date Format</h3>
<p>Here you may define how in-game dates are displayed. Simply type in a date specification (see the <a href="http://www.php.net/date" rel="external">date()</a> documentation for a full list of formatting codes) and press "<?=lang('MANAGE_DATEFORMAT_SUBMIT')?>".</p>
<p>Note that format specifications involving the name of the current time zone (i.e. "e" and "T") cannot be used, as they will always display "UTC".</p>
<h3>Language</h3>
<p>By default, QM Promisance is available in English only, but if your server administrator has installed any additional language packs, you may select one here and play the game in a different language.</p>
<?
}
?>
